#include "linked_lib.h"

#include <UnitTest++/UnitTest++.h>
#include <memory>
#include <iostream>
#include <stdexcept>

using namespace std;

// Example test case for push_back
// Testing push_back on a singleton
TEST(Push_back_of_one_element) {
    // Initialize the input linked-list to push_back
    List xs = cons(514, nullptr);
    List ys = xs;

    push_back(xs, 2017211);

    // Check that the output is a 2-element linked-list with correct order
    CHECK_EQUAL(ys, xs);
    CHECK_EQUAL(514, xs->data);
    CHECK(xs->next != nullptr);
    CHECK_EQUAL(2017211, xs->next->data);
    // Note: It is impossible to apply CHECK_EQUAL on nullptr, so we use
    // CHECK and manually compares for equality
    CHECK(xs->next->next == nullptr);
}

// This function overloads the '<<' operator to enable printing on List
// types. For example, 'cout << xs << '\n';' will compile and print its
// content. However, we are still not able to write tests such as
// CHECK_EQUAL(nullptr, xs) since nullptr might be of any pointer type
// and the '<<' operator does not know how to print it.
ostream& operator<<(ostream& out, const List& lst)
{
    if (lst) {
        out << "<ListNode@" << static_cast<void*>(lst.get());
        out << " data=" << lst->data;
        out << " next=" << static_cast<void*>(lst->next.get());
        out << ">";
    } else {
        out << "(nullptr)";
    }
    return out;
}
